//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37FDFDFD9708.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37FDFDFD9708.cm

//## begin module%37FDFDFD9708.cp preserve=no
//## end module%37FDFDFD9708.cp

//## Module: RealResponse%37FDFDFD9708; Package specification
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/Detector/RealResponse.h

#ifndef REALRESPONSE_H
#define REALRESPONSE_H 1

//## begin module%37FDFDFD9708.additionalIncludes preserve=no
//## end module%37FDFDFD9708.additionalIncludes

//## begin module%37FDFDFD9708.includes preserve=yes
//## end module%37FDFDFD9708.includes

// xsTypes
#include <main/xsTypes.h>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// Reference
#include <XSUtil/Utils/Reference.h>
// Response
#include <XSModel/Data/Detector/Response.h>
// RMF
#include <XSModel/Data/Detector/RMF.h>
//## begin module%37FDFDFD9708.declarations preserve=no
//## end module%37FDFDFD9708.declarations

//## begin module%37FDFDFD9708.additionalDeclarations preserve=yes
//## end module%37FDFDFD9708.additionalDeclarations


//## begin RealResponse%37FDF6AF1F30.preface preserve=yes
//## end RealResponse%37FDF6AF1F30.preface

//## Class: RealResponse%37FDF6AF1F30; Abstract
//## Category: XSModel::Data::Detector%36349D570394
//## Subsystem: XSModel::Data::Detector%367691B76668
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39FDA2650267;Model { -> }
//## Uses: <unnamed>%3A92D71902F5;RMF { -> }
//## Uses: <unnamed>%3DF61CD00171;SumComponent { -> }

class RealResponse : public Response  //## Inherits: <unnamed>%37FDF6C27C90
{
  //## begin RealResponse%37FDF6AF1F30.initialDeclarations preserve=yes
  //## end RealResponse%37FDF6AF1F30.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~RealResponse();


    //## Other Operations (specified)
      //## Operation: operator*%37FE06C538C0; C++
      //	Additional Public Declarations
      virtual Model& operator * (Model& model) const;

      //## Operation: read%3A368ECC0107
      virtual size_t read (const string& fileName, bool readFlag = true) = 0;

      //## Operation: closeSourceFiles%3A3A77E40036
      virtual void closeSourceFiles () = 0;

      //## Operation: setData%3A3A78170361
      void setData (size_t specNum, size_t groupNumber = 1, size_t nRmf = 0);

      //## Operation: readAuxResponse%3A758B6303DC
      virtual bool readAuxResponse (int rowNum = -1);

      //## Operation: clone%3A9566D10109
      virtual RealResponse* clone () const = 0;

      //## Operation: setEnergies%3AC4BC6C02B3
      virtual void setEnergies ();

      //## Operation: setSharedDescription%3ACA1F460279
      void setSharedDescription (size_t specNum, size_t groupNum);

      //## Operation: prepareForFit%3C3F15A703AB
      virtual void prepareForFit ();

      //## Operation: efficiency%3CF6341B020A
      virtual const RealArray& efficiency () const;

      //## Operation: sensitivity%3DE51AE903B2
      virtual RealArray sensitivity (const SpectralData* data);

      //## Operation: operator*%3DE7CE3D02B6; C++
      //	Convolution method for responses. Input model component,
      //	output folded model component.
      //	      //	For the time being implement output as Real
      //	Array.
      //	For the time being implement output as RealArray.
      //	There might be a better implementation that involved
      //	adding a folded array data member to the Component
      //	class. In the meantime the idea is to output the
      //	RealArray folded component and sum for the total
      //	model.
      //	      //	This must be modified to throw a YellowAlert
      //	Exception
      //	This must be modified to throw a YellowAlert Exception
      //	for invalid computations and to throw standard numeric
      //	exceptions.
      virtual void operator * (SumComponent& source) const;

      //## Operation: makeDerivative%415B0EC403B3
      virtual void makeDerivative (Real delta, RealArray& deriv, Response::ResponseParType parType);

      //## Operation: calcEffAreaPerChan%42136C2E0080
      virtual void calcEffAreaPerChan (RealArray& effArea);

      //## Operation: toRealResponse%43AC5562034C
      virtual const RealResponse* toRealResponse () const;

      //## Operation: setZeroGainEffectiveArea%4A0C87750331
      //	This does nothing unless the savedEffectiveArea array
      //	has already been initialized due to an earlier gain
      //	call.  But once it's initialized, the arf command needs
      //	this function to keep it updated when ARF modifications
      //	are made.
      void setZeroGainEffectiveArea (const RealArray& newEffArea);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: rmfName%3AC35616002D
      const string& rmfName () const;
      void rmfName (const string& value);

      //## Attribute: arfName%3C03AD3301A9
      const string& arfName () const;
      void arfName (const string& value);

      //## Attribute: arfRow%3EB93196000C
      size_t arfRow () const;
      void arfRow (size_t value);

      //## Attribute: rspRunPath%41A4B1D102AE
      const string& rspRunPath () const;
      void rspRunPath (const string& value);

      //## Attribute: arfRunPath%41A4B1E0019A
      const string& arfRunPath () const;
      void arfRunPath (const string& value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::Detector::ARF%3A707B89019E
      //## Role: RealResponse::effectiveArea%3A707B8A034D
      //## Qualifier: index%3A707C9302D7; size_t
      const RealArray& effectiveArea () const;
      void setEffectiveArea (const RealArray& value);
      Real effectiveArea (size_t index) const;
      void effectiveArea (size_t index, Real value);

      //## Association: XSModel::Data::Detector::RMF Pointer%3A92D625016E
      //## Role: RealResponse::rmfData%3A92D625016F
      const RefCountPtr< RMF >& rmfData () const;
      void rmfData (const RefCountPtr< RMF >& value);

      //## Association: XSModel::Data::Detector::<unnamed>%3AC10B04006A
      //## Role: RealResponse::source%3AC10B050269
      virtual SpectralData* source () const;
      virtual void source (SpectralData* value);

    // Additional Public Declarations
      //## begin RealResponse%37FDF6AF1F30.public preserve=yes
      //## end RealResponse%37FDF6AF1F30.public

  protected:
    //## Constructors (generated)
      RealResponse();

      RealResponse(const RealResponse &right);


    //## Other Operations (specified)
      //## Operation: setArrays%3A378B1E00D9
      virtual void setArrays () = 0;

      //## Operation: setDescription%3A378B220227
      virtual void setDescription (size_t specNum, size_t groupNum) = 0;

      //## Operation: Swap%3A956ADB00C0
      //## Exceptions: ()
      virtual void Swap (RealResponse& right) throw ();

      //## Operation: eboundsMin%3BDDBE420342
      virtual const RealArray& eboundsMin () const;

      //## Operation: eboundsMax%3BDDBE70004B
      virtual const RealArray& eboundsMax () const;

      //## Operation: shiftEffectiveArea%4140791503D6
      virtual void shiftEffectiveArea (const RealArray& newEnergies);

      //## Operation: restoreEffectiveArea%414092A20018
      virtual void restoreEffectiveArea ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::Detector::Noticed Response Elements%3DE5354203CD
      //## Role: RealResponse::noticedElements%3DE53544004A
      //## Qualifier: index%3DE5355F0073; size_t
      const IntegerArray& noticedElements () const;
      int noticedElements (size_t index) const;

      //## Association: XSModel::Data::Detector::Noticed Response Element Position%3DE535B20061
      //## Role: RealResponse::noticedElemPos%3DE535B3009C
      //## Qualifier: index%3DE5360C0280; size_t
      const IntegerArray& noticedElemPos () const;
      int noticedElemPos (size_t index) const;

    // Additional Protected Declarations
      //## begin RealResponse%37FDF6AF1F30.protected preserve=yes
      //## end RealResponse%37FDF6AF1F30.protected

  private:
    //## Assignment Operation (generated)
      RealResponse & operator=(const RealResponse &right);


    //## Other Operations (specified)
      //## Operation: copy%3A95675F0033
      virtual void copy (const RealResponse& right) = 0;

      //## Operation: RMFremove%3B9013250238
      virtual void RMFremove ();

      //## Operation: order%3B94E93900B8
      virtual bool order (const Response& right) const;

      //## Operation: convolve%3C3F14DC0199
      virtual void convolve (const RealArray& flux, const RealArray& fluxErr, RealArray& foldFlux, RealArray& foldFluxErr) const;

    // Additional Private Declarations
      //## begin RealResponse%37FDF6AF1F30.private preserve=yes
      //## end RealResponse%37FDF6AF1F30.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin RealResponse::rmfName%3AC35616002D.attr preserve=no  public: string {U} 
      string m_rmfName;
      //## end RealResponse::rmfName%3AC35616002D.attr

      //## begin RealResponse::arfName%3C03AD3301A9.attr preserve=no  public: string {U} 
      string m_arfName;
      //## end RealResponse::arfName%3C03AD3301A9.attr

      //## begin RealResponse::arfRow%3EB93196000C.attr preserve=no  public: size_t {U} 
      size_t m_arfRow;
      //## end RealResponse::arfRow%3EB93196000C.attr

      //## Attribute: savedEffectiveArea%414079800151
      //	m_savedEffectiveArea retains the effective area for the
      //	case of zero gain.  It does not even get initialized
      //	until the first time gain is called for this response,
      //	therefore in most sessions this remains empty.  If it is
      //	in use, it will need updating every time the arf command
      //	modifies the ARF.
      //## begin RealResponse::savedEffectiveArea%414079800151.attr preserve=no  private: RealArray {U} 
      RealArray m_savedEffectiveArea;
      //## end RealResponse::savedEffectiveArea%414079800151.attr

      //## begin RealResponse::rspRunPath%41A4B1D102AE.attr preserve=no  public: string {U} 
      string m_rspRunPath;
      //## end RealResponse::rspRunPath%41A4B1D102AE.attr

      //## begin RealResponse::arfRunPath%41A4B1E0019A.attr preserve=no  public: string {U} 
      string m_arfRunPath;
      //## end RealResponse::arfRunPath%41A4B1E0019A.attr

    // Data Members for Associations

      //## Association: XSModel::Data::Detector::ARF%3A707B89019E
      //## begin RealResponse::effectiveArea%3A707B8A034D.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_effectiveArea;
      //## end RealResponse::effectiveArea%3A707B8A034D.role

      //## Association: XSModel::Data::Detector::RMF Pointer%3A92D625016E
      //## begin RealResponse::rmfData%3A92D625016F.role preserve=no  public: RefCountPtr< RMF > { -> 1RHgN}
      RefCountPtr< RMF > m_rmfData;
      //## end RealResponse::rmfData%3A92D625016F.role

      //## Association: XSModel::Data::Detector::<unnamed>%3AC10B04006A
      //## begin RealResponse::source%3AC10B050269.role preserve=no  public: SpectralData { -> 1RHgN}
      SpectralData* m_source;
      //## end RealResponse::source%3AC10B050269.role

      //## Association: XSModel::Data::Detector::Noticed Response Elements%3DE5354203CD
      //## begin RealResponse::noticedElements%3DE53544004A.role preserve=no  protected: IntegerArray { -> 1..nVHgN}
      IntegerArray m_noticedElements;
      //## end RealResponse::noticedElements%3DE53544004A.role

      //## Association: XSModel::Data::Detector::Noticed Response Element Position%3DE535B20061
      //## begin RealResponse::noticedElemPos%3DE535B3009C.role preserve=no  protected: IntegerArray { -> 1..nVHgN}
      IntegerArray m_noticedElemPos;
      //## end RealResponse::noticedElemPos%3DE535B3009C.role

    // Additional Implementation Declarations
      //## begin RealResponse%37FDF6AF1F30.implementation preserve=yes
      //## end RealResponse%37FDF6AF1F30.implementation

};

//## begin RealResponse%37FDF6AF1F30.postscript preserve=yes
//## end RealResponse%37FDF6AF1F30.postscript

// Class RealResponse 


//## Other Operations (inline)
inline const RealResponse* RealResponse::toRealResponse () const
{
  //## begin RealResponse::toRealResponse%43AC5562034C.body preserve=yes
   return this;
  //## end RealResponse::toRealResponse%43AC5562034C.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& RealResponse::rmfName () const
{
  //## begin RealResponse::rmfName%3AC35616002D.get preserve=no
  return m_rmfName;
  //## end RealResponse::rmfName%3AC35616002D.get
}

inline void RealResponse::rmfName (const string& value)
{
  //## begin RealResponse::rmfName%3AC35616002D.set preserve=no
  m_rmfName = value;
  //## end RealResponse::rmfName%3AC35616002D.set
}

inline const string& RealResponse::arfName () const
{
  //## begin RealResponse::arfName%3C03AD3301A9.get preserve=no
  return m_arfName;
  //## end RealResponse::arfName%3C03AD3301A9.get
}

inline void RealResponse::arfName (const string& value)
{
  //## begin RealResponse::arfName%3C03AD3301A9.set preserve=no
  m_arfName = value;
  //## end RealResponse::arfName%3C03AD3301A9.set
}

inline size_t RealResponse::arfRow () const
{
  //## begin RealResponse::arfRow%3EB93196000C.get preserve=no
  return m_arfRow;
  //## end RealResponse::arfRow%3EB93196000C.get
}

inline void RealResponse::arfRow (size_t value)
{
  //## begin RealResponse::arfRow%3EB93196000C.set preserve=no
  m_arfRow = value;
  //## end RealResponse::arfRow%3EB93196000C.set
}

inline const string& RealResponse::rspRunPath () const
{
  //## begin RealResponse::rspRunPath%41A4B1D102AE.get preserve=no
  return m_rspRunPath;
  //## end RealResponse::rspRunPath%41A4B1D102AE.get
}

inline void RealResponse::rspRunPath (const string& value)
{
  //## begin RealResponse::rspRunPath%41A4B1D102AE.set preserve=no
  m_rspRunPath = value;
  //## end RealResponse::rspRunPath%41A4B1D102AE.set
}

inline const string& RealResponse::arfRunPath () const
{
  //## begin RealResponse::arfRunPath%41A4B1E0019A.get preserve=no
  return m_arfRunPath;
  //## end RealResponse::arfRunPath%41A4B1E0019A.get
}

inline void RealResponse::arfRunPath (const string& value)
{
  //## begin RealResponse::arfRunPath%41A4B1E0019A.set preserve=no
  m_arfRunPath = value;
  //## end RealResponse::arfRunPath%41A4B1E0019A.set
}

//## Get and Set Operations for Associations (inline)

inline const RealArray& RealResponse::effectiveArea () const
{
  //## begin RealResponse::effectiveArea%3A707B8A034D.get preserve=no
  return m_effectiveArea;
  //## end RealResponse::effectiveArea%3A707B8A034D.get
}

inline void RealResponse::setEffectiveArea (const RealArray& value)
{
  //## begin RealResponse::setEffectiveArea%3A707B8A034D.set preserve=yes
  m_effectiveArea.resize(value.size(),0);
  m_effectiveArea = value;
  //## end RealResponse::setEffectiveArea%3A707B8A034D.set
}

inline Real RealResponse::effectiveArea (size_t index) const
{
  //## begin RealResponse::effectiveArea%3A707B8A034D.qualget preserve=no
  return m_effectiveArea[index];
  //## end RealResponse::effectiveArea%3A707B8A034D.qualget
}

inline void RealResponse::effectiveArea (size_t index, Real value)
{
  //## begin RealResponse::effectiveArea%3A707B8A034D.qualset preserve=no
  m_effectiveArea[index] = value;
  //## end RealResponse::effectiveArea%3A707B8A034D.qualset
}

inline const RefCountPtr< RMF >& RealResponse::rmfData () const
{
  //## begin RealResponse::rmfData%3A92D625016F.get preserve=no
  return m_rmfData;
  //## end RealResponse::rmfData%3A92D625016F.get
}

inline void RealResponse::rmfData (const RefCountPtr< RMF >& value)
{
  //## begin RealResponse::rmfData%3A92D625016F.set preserve=no
  m_rmfData = value;
  //## end RealResponse::rmfData%3A92D625016F.set
}

inline SpectralData* RealResponse::source () const
{
  //## begin RealResponse::source%3AC10B050269.get preserve=no
  return m_source;
  //## end RealResponse::source%3AC10B050269.get
}

inline void RealResponse::source (SpectralData* value)
{
  //## begin RealResponse::source%3AC10B050269.set preserve=no
  m_source = value;
  //## end RealResponse::source%3AC10B050269.set
}

inline const IntegerArray& RealResponse::noticedElements () const
{
  //## begin RealResponse::noticedElements%3DE53544004A.get preserve=no
  return m_noticedElements;
  //## end RealResponse::noticedElements%3DE53544004A.get
}

inline int RealResponse::noticedElements (size_t index) const
{
  //## begin RealResponse::noticedElements%3DE53544004A.qualget preserve=no
  return m_noticedElements[index];
  //## end RealResponse::noticedElements%3DE53544004A.qualget
}

inline const IntegerArray& RealResponse::noticedElemPos () const
{
  //## begin RealResponse::noticedElemPos%3DE535B3009C.get preserve=no
  return m_noticedElemPos;
  //## end RealResponse::noticedElemPos%3DE535B3009C.get
}

inline int RealResponse::noticedElemPos (size_t index) const
{
  //## begin RealResponse::noticedElemPos%3DE535B3009C.qualget preserve=no
  return m_noticedElemPos[index];
  //## end RealResponse::noticedElemPos%3DE535B3009C.qualget
}

//## begin module%37FDFDFD9708.epilog preserve=yes
//## end module%37FDFDFD9708.epilog


#endif
